/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): .

====================================================================*/

package org.objectweb.corba.command;

/**
 * This class is launched by the idl3_start script.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.1
 */

public class Compiler
       extends org.objectweb.ccm.CORBA.ApplicationServer
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    Compiler()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     ** The main bootstrap method.
     **/
    public static void
    main(String[] args)
    {
        Compiler ir3 = new Compiler();
        ir3.start(args);
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    //  Methods for the org.objectweb.ccm.CORBA.Application class.
    //
    // ==================================================================

    /**
     **  Before running the CORBA::ORB.
     **
     **  @param args The command line arguments.
     **
     **  @return The status.
     **/
    public int
    before_run(String[] args)
    {
        try {

        // Create an OMG IDL3 repository.
        //        org.objectweb.ccm.IR3.IFR repositoryServer =
        //          new org.objectweb.ccm.IR3.IFR();
        //      org.omg.CORBA.ComponentIR.Repository repositoryRef =
        //               repositoryServer.getRepository().asComponentRepository();

        // Obtain the Interface Repository.
            org.omg.CORBA.ComponentIR.Repository repositoryRef =
                org.objectweb.ccm.CORBA.TheInterfaceRepository.getRepository();


            org.objectweb.corba.ast.api.AST ast = new org.objectweb.corba.ast.lib.Repository(repositoryRef);

            for(int i=0; i<args.length; i++)
            {
                org.objectweb.corba.parser.api.Parser parser =
                       new org.objectweb.corba.parser.lib.Parser(
                                               new java.io.FileInputStream(args[i]),
                                               ast,
                                               new org.objectweb.corba.parser.lib.ErrorManager(args[i]));

                parser.parseCIDL();
            }

        } catch(Exception exc) {
            exc.printStackTrace();
        }

        return 1;
    }

    /**
     **  After running the CORBA::ORB.
     **/
    public void
    after_run() {}

}
